# -*- coding: utf-8 -*-
"""Regression_reseau_neurones.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1wNnpg8Vtp6hzD5dekccd7rYvmtfF4jNH

# B. Réseau de neurones : Prédiction de la force de frottement sur un chariot à partir de sa vitesse
TP proposé par **Simon Kirchhofer**. Contact : simon.kirchhofer@ens-rennes.fr


<img src="https://drive.google.com/uc?id=1NcyMHqvLVIUD2sugrCzJBD_HA2NLWn6h" width="100">

Ce TP est la suite de la partie A implémentée sur matlab par Génolé Cherot. https://gitlab.com/Guenole.cherot/liesse/-/tree/master/Regression

Dans cette partie, nous allons effectuer la regression avec un réseau de neurones en python avec la librairie Keras.

## Importation des bibliothèques
"""

# Commented out IPython magic to ensure Python compatibility.
# %pip install scikit-learn==1.0.2
# %pip install tensorflow==2.8.2
# %pip install matplotlib==3.2.2
# %pip install pandas==1.3.5

# TensorFlow and tf.keras
import tensorflow as tf
from tensorflow import keras
from sklearn.metrics import ConfusionMatrixDisplay
from sklearn.metrics import confusion_matrix
from sklearn.metrics import mean_squared_error

import pandas as pd

# Helper libraries
import numpy as np
import matplotlib.pyplot as plt

"""## Importation des données

Via Colab 
1.   Le dossier data_regression est partagé. Il contient toutes les données : https://drive.google.com/drive/folders/1ejKsqHetZE_gSUEaEaXQjd5b5RW1t-gv?usp=sharing
2.   En suivant le lien précédent, clique droit sur le titre du dossier "data_regression" "ajouter un raccourci à drive" et laisser la selection par défault "mon drive" Pour poser le chemin du dossier à la racine du drive
3.   La section suivante donne à colab l'accès au drive associé. On y retrouve les dossiers partagés, dont "data_regression"

En local sur votre machine :
1.  télécharger le dossier avec la base de données : https://drive.google.com/drive/folders/1ejKsqHetZE_gSUEaEaXQjd5b5RW1t-gv?usp=sharing
2.  Dans la cellule suivante, modifier la variable "path" pour qu'elle pointe vers le fichier .CSV téléchargé
"""

from google.colab import drive
drive.mount('/content/drive')

file_path = 'drive/MyDrive/data_regression/data.csv' ## Attention, en local, modifier le chemin pour pointer vers le fichier .csv téléchargé
df=pd.read_csv(file_path, sep=',',header=None)

"""##Traitement de la base de données"""

V = np.copy(df.values[:,0]) # Extraction des vitesses
F = np.copy(df.values[:,1]) # Extraction des forces de frottement

# Affichage de la base de données
plt.figure()
plt.plot(V, F, 'o', c='blue')
plt.xlabel('Vitesse (m/s)')
plt.ylabel('Force (N)')
plt.title('Base de données')

# Normalisation des données entre 0 et 1. Permet un meilleur apprentissage sans explosion du gradient.
# Les vitesses sont comprises entre 0 et 1200 m/s. Les forces sont comprises entre 0 et 50N
V/=1200
F/=50

# Affichage de la base de données normalisée
plt.figure()
plt.plot(V, F, 'o', c='blue')
plt.xlabel('Vitesse normalisée')
plt.ylabel('Force normalisée')
plt.title('Base de données')

plt.show()

"""##Préparation des données

Séparation apprentissage / test
"""

np.random.seed(0)

test_size = 0.2 # on sort 20% du jeu de données pour les test
test_idx = np.random.choice(range(len(V)), size=int(len(V)*test_size), replace=False) # 20% sont choisis dans la base de données pour faire la base de test
train_idx = np.delete(range(len(V)),test_idx) # Les mêmes 20% sont supprimés de la base de données obtenir la base d'apprentissage
x_test = V[test_idx]
y_test = F[test_idx]
x_train = V[train_idx]
y_train = F[train_idx]

# Affichage de la base d'apprentissage et de test
plt.figure()
plt.plot(x_train, y_train, 'o', c='red', label = 'apprentissage')
plt.plot(x_test, y_test, 'o', c='green', label = 'test')
plt.xlabel('Vitesse normalisée')
plt.ylabel('Force normalisée')
plt.legend()

plt.show()

"""##Choix de l'architecture du réseau de neurones

Le problème semble simple, nous utiliserons donc une structure simple avec une couche et 10 neurones.
Comme nous voulons réaliser une regression, nous utiliserons une fonction d'activation linéaire pour la couche de sortie
"""

model = tf.keras.Sequential([
    tf.keras.layers.Dense(10, activation='relu',input_shape=(1,)), # Une couche avec 10 neurones, une fonction d'activation linéaire rectifiée. L'entrée est de taille 1 car il s'agit d'une mesure de vitesse
    tf.keras.layers.Dense(1, activation='linear'), # La couche de sortie a un neurone car nous faisons une regression sur 1 valeur : la force. La fonction d'activation linéaire est adaptée à la regression
])

opt = keras.optimizers.Adam(learning_rate=0.001) # Choix de l'optimiseur et du learning rate
model.compile(optimizer=opt,
              loss=tf.keras.losses.MeanSquaredError()) # La fonction de cout est une fonction quadratique (MeanSquaredError)

model.summary()

"""##Apprentissage

Début de l'apprentissage. Il faut spécifier le pourcentage de données pour la validation (ici 20%) et le nombre de fois que le réseau va parcourir toutes les données (nombre d'epoch)
"""

# le modèle est entrainé sur la base d'apprentissage. Les deux premiers paramètre de model.fit sont :
# x, y sont les entrées et sorties du modèle
# validation_split=0.2 -> 20% de la base d'apprentissage est utilisée pour la validation
# epochs=100 -> Le reseau fait une propagation + rétropropagation sur la totalité de la base d'apprentissage 100 fois

epochs=100
history = model.fit(x = x_train, y = y_train,
  validation_split=0.2, 
  epochs=epochs
)

"""##Affichage de l'évolution du coût et de la précision pendant l'apprentissage

Que peut on en déduire ? L'apprentissage est il acceptable ?
"""

loss = history.history['loss'] # Tracé de la fonction de coût sur les données d'apprentissage en fonction de l'epoch
val_loss = history.history['val_loss'] # Tracé de la fonction de coût sur les données de validation en fonction de l'epoch
epochs_range = range(len(history.history['loss']))

# Affichage de l'evolution des fonctions de coût
plt.figure()
plt.plot(epochs_range, loss, label='Fonction de coût pour l\'apprentissage')
plt.plot(epochs_range, val_loss, label='Fonction de coût pour la validation')
plt.legend(loc='upper right')
plt.title('fonction de coût (erreur) pour l\'apprentissage et la validation')
plt.show()

"""## Prédiction de la base de test"""

y_predicted = model.predict(x_test)
print('la fonction de coût sur la base de test est : ' + str(mean_squared_error(y_test,y_predicted)))

"""La valeur de la fonction de coût (loss) sur la base de test est à comparer avec la loss de la validation. Si les loss sont proches, alors l'apprentissage a correctement convergé

## Affichage des résultats
"""

# Affichage de la base de test. Comparaison entre prediction et vérité terrain
plt.figure()
plt.plot(x_test, y_test, 'o', c='red', label = 'base de test')
plt.plot(x_test, y_predicted, 'x', c='blue', label = 'prediction')
plt.xlabel('Vitesse normalisée')
plt.ylabel('Force normalisée')
plt.legend()

plt.show()